<!DOCTYPE html>
<html lang="en">
  <head>
    <title>HaishinKit  Reference</title>
    <link rel="stylesheet" type="text/css" href="css/jazzy.css" />
    <link rel="stylesheet" type="text/css" href="css/highlight.css" />
    <meta charset='utf-8'>
    <script src="js/jquery.min.js" defer></script>
    <script src="js/jazzy.js" defer></script>
    
    <script src="js/lunr.min.js" defer></script>
    <script src="js/typeahead.jquery.js" defer></script>
    <script src="js/jazzy.search.js" defer></script>
  </head>
  <body>
    <a title="HaishinKit  Reference"></a>
    <header>
      <div class="content-wrapper">
        <p><a href="index.html">HaishinKit 1.8.0 Docs</a> (88% documented)</p>
        <div class="header-right">
          <form role="search" action="search.json">
            <input type="text" placeholder="Search documentation" data-typeahead>
          </form>
        </div>
      </div>
    </header>
    <div class="content-wrapper">
      <p id="breadcrumbs">
        <a href="index.html">HaishinKit Reference</a>
        <img id="carat" src="img/carat.png" alt=""/>
        HaishinKit  Reference
      </p>
    </div>
    <div class="content-wrapper">
      <nav class="sidebar">
        <ul class="nav-groups">
          <li class="nav-group-name">
            <a href="Classes.html">Classes</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Classes/ByteArray.html">ByteArray</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/ByteArray/Error.html">– Error</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/Event.html">Event</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/Event/Name.html">– Name</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/EventDispatcher.html">EventDispatcher</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOAudioCaptureUnit.html">IOAudioCaptureUnit</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStream.html">IOStream</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStream/ReadyState.html">– ReadyState</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStreamBitRateStrategy.html">IOStreamBitRateStrategy</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStreamRecorder.html">IOStreamRecorder</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStreamRecorder/Error.html">– Error</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStreamVideoAdaptiveBitRateStrategy.html">IOStreamVideoAdaptiveBitRateStrategy</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOVideoCaptureUnit.html">IOVideoCaptureUnit</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/InstanceHolder.html">InstanceHolder</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MTHKView.html">MTHKView</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/NetClient.html">NetClient</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/NetService.html">NetService</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/NetSocket.html">NetSocket</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/PiPHKView.html">PiPHKView</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/PiPHKView.html">PiPHKView</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPConnection.html">RTMPConnection</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPConnection/Code.html">– Code</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPResponder.html">RTMPResponder</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPSharedObject.html">RTMPSharedObject</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPStream.html">RTMPStream</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPStream/Code.html">– Code</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPStream/HowToPublish.html">– HowToPublish</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/SRTConnection.html">SRTConnection</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/SRTLogger.html">SRTLogger</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/SRTStream.html">SRTStream</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/TSReader.html">TSReader</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/TSWriter.html">TSWriter</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/VideoEffect.html">VideoEffect</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Global%20Variables.html">Global Variables</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Global%20Variables.html#/s:10HaishinKit12kASUndefinedAA0C0Vvp">kASUndefined</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Enums.html">Enumerations</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Enums/DeviceUtil.html">DeviceUtil</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/DeviceUtil.html">DeviceUtil</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/FeatureUtil.html">FeatureUtil</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/FeatureUtil/Name.html">– Name</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/IOAudioMixerError.html">IOAudioMixerError</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/IOAudioUnitError.html">IOAudioUnitError</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/IOVideoUnitError.html">IOVideoUnitError</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/ImageTransform.html">ImageTransform</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/RTMPObjectEncoding.html">RTMPObjectEncoding</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/SRTLogFunctionalArea.html">SRTLogFunctionalArea</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/SRTLogLevel.html">SRTLogLevel</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/SRTMode.html">SRTMode</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/SRTSocketOption.html">SRTSocketOption</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Extensions.html">Extensions</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Extensions.html#/s:13SRTHaishinKit9SRTSocketC">SRTSocket</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Protocols.html">Protocols</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Protocols/EventDispatcherConvertible.html">EventDispatcherConvertible</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOMuxer.html">IOMuxer</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamBitRateStrategyConvertible.html">IOStreamBitRateStrategyConvertible</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamDelegate.html">IOStreamDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamObserver.html">IOStreamObserver</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamRecorderDelegate.html">IOStreamRecorderDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamView.html">IOStreamView</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/RTMPConnectionDelegate.html">RTMPConnectionDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/Running.html">Running</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/TSReaderDelegate.html">TSReaderDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/TSWriterDelegate.html">TSWriterDelegate</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Structs.html">Structures</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Structs/ASArray.html">ASArray</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/ASTypedObject.html">ASTypedObject</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/ASUndefined.html">ASUndefined</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/ASXML.html">ASXML</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/ASXMLDocument.html">ASXMLDocument</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/Atomic.html">Atomic</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/AudioCodecSettings.html">AudioCodecSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOAudioMixerSettings.html">IOAudioMixerSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOAudioMixerTrackSettings.html">IOAudioMixerTrackSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOStreamBitRateStats.html">IOStreamBitRateStats</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOVideoMixerSettings.html">IOVideoMixerSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOVideoMixerSettings/Mode.html">– Mode</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/RTMPStreamInfo.html">RTMPStreamInfo</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/SRTPerformanceData.html">SRTPerformanceData</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/SoundTransform.html">SoundTransform</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/VTSessionOption.html">VTSessionOption</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/VideoCodecSettings.html">VideoCodecSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/VideoCodecSettings/BitRateMode.html">– BitRateMode</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/VideoCodecSettings/ScalingMode.html">– ScalingMode</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Typealiases.html">Type Aliases</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:10HaishinKit8ASObjecta">ASObject</a>
              </li>
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:10HaishinKit32IOAudioCaptureConfigurationBlocka">IOAudioCaptureConfigurationBlock</a>
              </li>
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:10HaishinKit32IOVideoCaptureConfigurationBlocka">IOVideoCaptureConfigurationBlock</a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <article class="main-content">
        <section>
          <section class="section">
            
            <h1 id='haishinkit-for-ios-macos-tvos-visionos-and-a-href-https-github-com-shogo4405-haishinkit-kt-android-a' class='heading'>HaishinKit for iOS, macOS, tvOS, visionOS and <a href="https://github.com/shogo4405/HaishinKit.kt">Android</a>.</h1>

<p><a href="https://github.com/shogo4405/HaishinKit.swift/stargazers"><img src="https://img.shields.io/github/stars/shogo4405/HaishinKit.swift?style=social" alt="GitHub Stars"></a>
<a href="https://github.com/shogo4405/HaishinKit.swift/releases/latest"><img src="https://img.shields.io/github/v/release/shogo4405/HaishinKit.swift" alt="Release"></a>
<a href="https://swiftpackageindex.com/shogo4405/HaishinKit.swift"><img src="https://img.shields.io/endpoint?url=https%3A%2F%2Fswiftpackageindex.com%2Fapi%2Fpackages%2Fshogo4405%2FHaishinKit.swift%2Fbadge%3Ftype%3Dplatforms" alt="Platform Compatibility"></a>
<a href="https://swiftpackageindex.com/shogo4405/HaishinKit.swift"><img src="https://img.shields.io/endpoint?url=https%3A%2F%2Fswiftpackageindex.com%2Fapi%2Fpackages%2Fshogo4405%2FHaishinKit.swift%2Fbadge%3Ftype%3Dswift-versions" alt="Swift Compatibility"></a>
<a href="https://raw.githubusercontent.com/shogo4405/HaishinKit.swift/master/LICENSE.md"><img src="https://img.shields.io/badge/License-BSD%203--Clause-blue.svg" alt="GitHub license"></a>
<a href="https://github.com/sponsors/shogo4405"><img src="https://img.shields.io/static/v1?label=Sponsor&message=%E2%9D%A4&logo=GitHub&color=ff69b4" alt="GitHub Sponsor"></a></p>

<ul>
<li>Camera and Microphone streaming library via RTMP and SRT for iOS, macOS, tvOS and visionOS.</li>
<li>README.md contains unreleased content, which can be tested on the main branch.</li>
<li><a href="https://shogo4405.github.io/HaishinKit.swift/">API Documentation</a></li>
</ul>

<p align="center">
<strong>Sponsored with 💖 by</strong><br />
<a href="https://getstream.io/chat/sdk/ios/?utm_source=https://github.com/shogo4405/HaishinKit.swift&utm_medium=github&utm_content=developer&utm_term=swift" target="_blank">
<img src="https://stream-blog-v2.imgix.net/blog/wp-content/uploads/f7401112f41742c4e173c30d4f318cb8/stream_logo_white.png?w=350" alt="Stream Chat" style="margin: 8px" />
</a>
<br />
Enterprise Grade APIs for Feeds & Chat. <a href="https://getstream.io/tutorials/ios-chat/?utm_source=github.com/shogo4405/HaishinKit.swift&utm_medium=github&utm_campaign=oss_sponsorship" target="_blank">Try the iOS Chat tutorial</a> 💬
</p>
<h2 id='communication' class='heading'>💬 Communication</h2>

<ul>
<li>If you need help with making LiveStreaming requests using HaishinKit, use a <a href="https://github.com/shogo4405/HaishinKit.swift/discussions">GitHub Discussions</a> with <strong>Q&amp;A</strong>.</li>
<li>If you&rsquo;d like to discuss a feature request, use a <a href="https://github.com/shogo4405/HaishinKit.swift/discussions">GitHub Discussions</a> with <strong>Idea</strong></li>
<li>If you met a HaishinKit&rsquo;s bug🐛, use a <a href="https://github.com/shogo4405/HaishinKit.swift/issues">GitHub Issue</a> with <strong>Bug report template</strong>

<ul>
<li>The trace level log is very useful. Please set <code>LBLogger.with(HaishinKitIdentifier).level = .trace</code>.</li>
<li>If you don&rsquo;t use an issue template. I will immediately close the your issue without a comment.</li>
</ul></li>
<li>If you <strong>want to contribute</strong>, submit a pull request with a pr template.</li>
<li>If you want to support e-mail based communication without GitHub.

<ul>
<li>Consulting fee is <a href="https://www.paypal.me/shogo4405/50USD">$50</a>/1 incident. I&rsquo;m able to response a few days.</li>
</ul></li>
<li><a href="https://discord.com/invite/8nkshPnanr">Discord chatroom</a>.</li>
<li>日本語が分かる方は、日本語でのコミニケーションをお願いします！</li>
</ul>
<h2 id='sponsors' class='heading'>💖 Sponsors</h2>

<p align="center">
  <br />
  <br />
  <a href="https://github.com/sponsors/shogo4405">Sponsorship</a>
  <br />
  <br />
</p>
<h2 id='related-projects' class='heading'>🌏 Related projects</h2>

<table><thead>
<tr>
<th>Project name</th>
<th>Notes</th>
<th>License</th>
</tr>
</thead><tbody>
<tr>
<td><a href="https://github.com/shogo4405/HaishinKit.kt">HaishinKit for Android.</a></td>
<td>Camera and Microphone streaming library via RTMP for Android.</td>
<td><a href="https://github.com/shogo4405/HaishinKit.kt/blob/master/LICENSE.md">BSD 3-Clause &ldquo;New&rdquo; or &ldquo;Revised&rdquo; License</a></td>
</tr>
<tr>
<td><a href="https://github.com/shogo4405/HaishinKit.dart">HaishinKit for Flutter.</a></td>
<td>Camera and Microphone streaming library via RTMP for Flutter.</td>
<td><a href="https://github.com/shogo4405/HaishinKit.dart/blob/master/LICENSE.md">BSD 3-Clause &ldquo;New&rdquo; or &ldquo;Revised&rdquo; License</a></td>
</tr>
</tbody></table>
<h2 id='features' class='heading'>🎨 Features</h2>
<h3 id='rtmp' class='heading'>RTMP</h3>

<ul>
<li>[x] Authentication</li>
<li>[x] Publish and Recording</li>
<li>[x] <em>Playback (Beta)</em></li>
<li>[x] <a href="../../issues/1308">Adaptive bitrate streaming</a></li>
<li>[ ] Action Message Format

<ul>
<li>[x] AMF0</li>
<li>[ ] AMF3</li>
</ul></li>
<li>[x] SharedObject</li>
<li>[x] RTMPS

<ul>
<li>[x] Native (RTMP over SSL/TLS)</li>
<li>[x] <em>Tunneled (RTMPT over SSL/TLS) (Technical Preview)</em></li>
</ul></li>
<li>[x] <em>RTMPT (Technical Preview)</em></li>
<li>[x] ReplayKit Live as a Broadcast Upload Extension</li>
<li>[x] <a href="https://github.com/veovera/enhanced-rtmp">Enhanced RTMP</a></li>
</ul>
<h3 id='srt-beta' class='heading'>SRT(beta)</h3>

<ul>
<li>[x] Publish and Recording (H264/AAC)</li>
<li>[x] Playback(beta)</li>
<li>[ ] mode

<ul>
<li>[x] caller</li>
<li>[ ] listener</li>
<li>[ ] rendezvous</li>
</ul></li>
</ul>
<h3 id='multi-camera' class='heading'>Multi Camera</h3>

<p>Supports two camera video sources. A picture-in-picture display that shows the image of the secondary camera of the primary camera. Supports camera split display that displays horizontally and vertically.</p>

<table><thead>
<tr>
<th style="text-align: center">Picture-In-Picture</th>
<th style="text-align: center">Split</th>
</tr>
</thead><tbody>
<tr>
<td style="text-align: center"><img width="1382" alt="" src="https://user-images.githubusercontent.com/810189/210043421-ceb18cb7-9b50-43fa-a0a2-8b92b78d9df1.png"></td>
<td style="text-align: center"><img width="1382" alt="" src="https://user-images.githubusercontent.com/810189/210043687-a99f21b6-28b2-4170-96de-6c814debd84d.png"></td>
</tr>
</tbody></table>
<pre class="highlight swift"><code><span class="c1">// If you want to use the multi-camera feature, please make sure stream.isMultiCamSessionEnabled = true. Before attachCamera or attachAudio.</span>
<span class="n">stream</span><span class="o">.</span><span class="n">isMultiCamSessionEnabled</span> <span class="o">=</span> <span class="kc">true</span>

<span class="k">let</span> <span class="nv">back</span> <span class="o">=</span> <span class="kt">AVCaptureDevice</span><span class="o">.</span><span class="nf">default</span><span class="p">(</span><span class="o">.</span><span class="n">builtInWideAngleCamera</span><span class="p">,</span> <span class="nv">for</span><span class="p">:</span> <span class="o">.</span><span class="n">video</span><span class="p">,</span> <span class="nv">position</span><span class="p">:</span> <span class="o">.</span><span class="n">back</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">attachCamera</span><span class="p">(</span><span class="n">back</span><span class="p">,</span> <span class="nv">track</span><span class="p">:</span> <span class="mi">0</span><span class="p">)</span> <span class="p">{</span> <span class="n">_</span><span class="p">,</span> <span class="n">error</span> <span class="k">in</span>
  <span class="k">if</span> <span class="k">let</span> <span class="nv">error</span> <span class="p">{</span>
    <span class="n">logger</span><span class="o">.</span><span class="nf">warn</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
  <span class="p">}</span>
<span class="p">}</span>

<span class="k">let</span> <span class="nv">front</span> <span class="o">=</span> <span class="kt">AVCaptureDevice</span><span class="o">.</span><span class="nf">default</span><span class="p">(</span><span class="o">.</span><span class="n">builtInWideAngleCamera</span><span class="p">,</span> <span class="nv">for</span><span class="p">:</span> <span class="o">.</span><span class="n">video</span><span class="p">,</span> <span class="nv">position</span><span class="p">:</span> <span class="o">.</span><span class="n">front</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">attachCamera</span><span class="p">(</span><span class="n">front</span><span class="p">,</span> <span class="nv">track</span><span class="p">:</span> <span class="mi">1</span><span class="p">)</span> <span class="p">{</span> <span class="n">videoUnit</span><span class="p">,</span> <span class="n">error</span> <span class="k">in</span>
  <span class="n">videoUnit</span><span class="p">?</span><span class="o">.</span><span class="n">isVideoMirrored</span> <span class="o">=</span> <span class="kc">true</span>
  <span class="k">if</span> <span class="k">let</span> <span class="nv">error</span> <span class="p">{</span>
    <span class="n">logger</span><span class="o">.</span><span class="nf">error</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
  <span class="p">}</span>
<span class="p">}</span>
</code></pre>
<h3 id='rendering' class='heading'>Rendering</h3>

<table><thead>
<tr>
<th>Features</th>
<th style="text-align: center"><a href="https://shogo4405.github.io/HaishinKit.swift/Classes/PiPHKView.html">PiPHKView</a></th>
<th style="text-align: center"><a href="https://shogo4405.github.io/HaishinKit.swift/Classes/MTHKView.html">MTHKView</a></th>
</tr>
</thead><tbody>
<tr>
<td>Engine</td>
<td style="text-align: center">AVSampleBufferDisplayLayer</td>
<td style="text-align: center">Metal</td>
</tr>
<tr>
<td>Publish</td>
<td style="text-align: center">✔</td>
<td style="text-align: center">✔</td>
</tr>
<tr>
<td>Playback</td>
<td style="text-align: center">✔</td>
<td style="text-align: center">✔</td>
</tr>
<tr>
<td>VisualEffect</td>
<td style="text-align: center">✔</td>
<td style="text-align: center">✔</td>
</tr>
<tr>
<td>MultiCamera</td>
<td style="text-align: center">✔</td>
<td style="text-align: center">✔</td>
</tr>
<tr>
<td>PictureInPicture</td>
<td style="text-align: center">✔</td>
<td style="text-align: center"><br /></td>
</tr>
</tbody></table>
<h3 id='others' class='heading'>Others</h3>

<ul>
<li>[x] tvOS 17.0 for AVCaptureSession.</li>
<li>[x] <a href="https://developer.apple.com/documentation/avfoundation/capture_setup/accessing_the_camera_while_multitasking">Support multitasking camera access.</a></li>
<li>[x] Support &ldquo;Allow app extension API only&rdquo; option</li>
</ul>
<h2 id='examples' class='heading'>🐾 Examples</h2>

<p>Examples project are available for iOS with UIKit, iOS with SwiftUI, macOS and tvOS. Example macOS requires Apple Silicon mac.</p>

<ul>
<li>[x] Camera and microphone publish.</li>
<li>[x] Playback
<code>sh
git clone https://github.com/shogo4405/HaishinKit.swift.git
cd HaishinKit.swift
carthage bootstrap --platform iOS,macOS,tvOS --use-xcframeworks
open HaishinKit.xcodeproj
</code></li>
</ul>
<h2 id='requirements' class='heading'>🌏 Requirements</h2>
<h3 id='development' class='heading'>Development</h3>

<table><thead>
<tr>
<th style="text-align: center">Version</th>
<th style="text-align: center">Xcode</th>
<th style="text-align: center">Swift</th>
</tr>
</thead><tbody>
<tr>
<td style="text-align: center">1.8.0+</td>
<td style="text-align: center">15.3+</td>
<td style="text-align: center">5.9+</td>
</tr>
<tr>
<td style="text-align: center">1.7.0+</td>
<td style="text-align: center">15.0+</td>
<td style="text-align: center">5.9+</td>
</tr>
<tr>
<td style="text-align: center">1.6.0+</td>
<td style="text-align: center">15.0+</td>
<td style="text-align: center">5.8+</td>
</tr>
</tbody></table>
<h3 id='os' class='heading'>OS</h3>

<table><thead>
<tr>
<th style="text-align: left">-</th>
<th style="text-align: center">iOS</th>
<th style="text-align: center">tvOS</th>
<th style="text-align: center">macOS</th>
<th style="text-align: center">visionOS</th>
<th style="text-align: center">watchOS</th>
</tr>
</thead><tbody>
<tr>
<td style="text-align: left">HaishinKit</td>
<td style="text-align: center">13.0+</td>
<td style="text-align: center">13.0+</td>
<td style="text-align: center">10.15+</td>
<td style="text-align: center">1.0+</td>
<td style="text-align: center">-</td>
</tr>
<tr>
<td style="text-align: left">SRTHaishinKit</td>
<td style="text-align: center">13.0+</td>
<td style="text-align: center">-</td>
<td style="text-align: center">13.0+</td>
<td style="text-align: center">-</td>
<td style="text-align: center">-</td>
</tr>
</tbody></table>
<h3 id='cocoa-keys' class='heading'>Cocoa Keys</h3>

<p>Please contains Info.plist.</p>

<p><strong>iOS 10.0+</strong></p>

<ul>
<li>NSMicrophoneUsageDescription</li>
<li>NSCameraUsageDescription</li>
</ul>

<p><strong>macOS 10.14+</strong></p>

<ul>
<li>NSMicrophoneUsageDescription</li>
<li>NSCameraUsageDescription</li>
</ul>

<p><strong>tvOS 17.0+</strong></p>

<ul>
<li>NSMicrophoneUsageDescription</li>
<li>NSCameraUsageDescription</li>
</ul>
<h2 id='installation' class='heading'>🔧 Installation</h2>

<p>HaishinKit has a multi-module configuration. If you want to use the SRT protocol, please use SRTHaishinKit. SRTHaishinKit supports SPM only.
|  | HaishinKit | SRTHaishinKit |
| - | :- | :- |
| SPM | <a href="https://github.com/shogo4405/HaishinKit.swift">https://github.com/shogo4405/HaishinKit.swift</a> | <a href="https://github.com/shogo4405/HaishinKit.swift">https://github.com/shogo4405/HaishinKit.swift</a> |
| CocoaPods | source &lsquo;<a href="https://github.com/CocoaPods/Specs.git">https://github.com/CocoaPods/Specs.git</a>&rsquo;<br>use_frameworks!<br><br>def import_pods<br>    pod &#39;HaishinKit&rsquo;, &lsquo;~&gt; 1.6.0<br>end<br><br>target &#39;Your Target&rsquo;  do<br>    platform :ios, &lsquo;12.0&rsquo;<br>    import_pods<br>end<br> | Not supported. |
| Carthage | github &ldquo;shogo4405/HaishinKit.swift&rdquo; ~&gt; 1.6.0 | Not supported. |</p>
<h2 id='prerequisites' class='heading'>🔧 Prerequisites</h2>

<p>Make sure you setup and activate your AVAudioSession iOS.</p>
<pre class="highlight swift"><code><span class="kd">import</span> <span class="kt">AVFoundation</span>
<span class="k">let</span> <span class="nv">session</span> <span class="o">=</span> <span class="kt">AVAudioSession</span><span class="o">.</span><span class="nf">sharedInstance</span><span class="p">()</span>
<span class="k">do</span> <span class="p">{</span>
    <span class="k">try</span> <span class="n">session</span><span class="o">.</span><span class="nf">setCategory</span><span class="p">(</span><span class="o">.</span><span class="n">playAndRecord</span><span class="p">,</span> <span class="nv">mode</span><span class="p">:</span> <span class="o">.</span><span class="k">default</span><span class="p">,</span> <span class="nv">options</span><span class="p">:</span> <span class="p">[</span><span class="o">.</span><span class="n">defaultToSpeaker</span><span class="p">,</span> <span class="o">.</span><span class="n">allowBluetooth</span><span class="p">])</span>
    <span class="k">try</span> <span class="n">session</span><span class="o">.</span><span class="nf">setActive</span><span class="p">(</span><span class="kc">true</span><span class="p">)</span>
<span class="p">}</span> <span class="k">catch</span> <span class="p">{</span>
    <span class="nf">print</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
<span class="p">}</span>
</code></pre>
<h2 id='rtmp-usage' class='heading'>📓 RTMP Usage</h2>
<h3 id='ingest' class='heading'>Ingest</h3>
<pre class="highlight swift"><code><span class="k">let</span> <span class="nv">connection</span> <span class="o">=</span> <span class="kt">RTMPConnection</span><span class="p">()</span>
<span class="k">let</span> <span class="nv">stream</span> <span class="o">=</span> <span class="kt">RTMPStream</span><span class="p">(</span><span class="nv">connection</span><span class="p">:</span> <span class="n">connection</span><span class="p">)</span>

<span class="n">stream</span><span class="o">.</span><span class="nf">attachAudio</span><span class="p">(</span><span class="kt">AVCaptureDevice</span><span class="o">.</span><span class="nf">default</span><span class="p">(</span><span class="nv">for</span><span class="p">:</span> <span class="o">.</span><span class="n">audio</span><span class="p">))</span> <span class="p">{</span> <span class="n">_</span><span class="p">,</span> <span class="n">error</span> <span class="k">in</span>
  <span class="k">if</span> <span class="k">let</span> <span class="nv">error</span> <span class="p">{</span>
    <span class="n">logger</span><span class="o">.</span><span class="nf">warn</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
  <span class="p">}</span>
<span class="p">}</span>

<span class="n">stream</span><span class="o">.</span><span class="nf">attachCamera</span><span class="p">(</span><span class="kt">AVCaptureDevice</span><span class="o">.</span><span class="nf">default</span><span class="p">(</span><span class="o">.</span><span class="n">builtInWideAngleCamera</span><span class="p">,</span> <span class="nv">for</span><span class="p">:</span> <span class="o">.</span><span class="n">video</span><span class="p">,</span> <span class="nv">position</span><span class="p">:</span> <span class="o">.</span><span class="n">back</span><span class="p">),</span> <span class="nv">track</span><span class="p">:</span> <span class="mi">0</span><span class="p">)</span> <span class="p">{</span> <span class="n">_</span><span class="p">,</span> <span class="n">error</span> <span class="k">in</span>
  <span class="k">if</span> <span class="k">let</span> <span class="nv">error</span> <span class="p">{</span>
    <span class="n">logger</span><span class="o">.</span><span class="nf">warn</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
  <span class="p">}</span>
<span class="p">}</span>

<span class="k">let</span> <span class="nv">hkView</span> <span class="o">=</span> <span class="kt">MTHKView</span><span class="p">(</span><span class="nv">frame</span><span class="p">:</span> <span class="n">view</span><span class="o">.</span><span class="n">bounds</span><span class="p">)</span>
<span class="n">hkView</span><span class="o">.</span><span class="n">videoGravity</span> <span class="o">=</span> <span class="kt">AVLayerVideoGravity</span><span class="o">.</span><span class="n">resizeAspectFill</span>
<span class="n">hkView</span><span class="o">.</span><span class="nf">attachStream</span><span class="p">(</span><span class="n">stream</span><span class="p">)</span>

<span class="c1">// add ViewController#view</span>
<span class="n">view</span><span class="o">.</span><span class="nf">addSubview</span><span class="p">(</span><span class="n">hkView</span><span class="p">)</span>

<span class="n">connection</span><span class="o">.</span><span class="nf">connect</span><span class="p">(</span><span class="s">"rtmp://localhost/appName/instanceName"</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">publish</span><span class="p">(</span><span class="s">"streamName"</span><span class="p">)</span>
</code></pre>
<h3 id='playback' class='heading'>Playback</h3>
<pre class="highlight swift"><code><span class="k">let</span> <span class="nv">connection</span> <span class="o">=</span> <span class="kt">RTMPConnection</span><span class="p">()</span>
<span class="k">let</span> <span class="nv">stream</span> <span class="o">=</span> <span class="kt">RTMPStream</span><span class="p">(</span><span class="nv">connection</span><span class="p">:</span> <span class="n">connection</span><span class="p">)</span>

<span class="k">let</span> <span class="nv">hkView</span> <span class="o">=</span> <span class="kt">MTHKView</span><span class="p">(</span><span class="nv">frame</span><span class="p">:</span> <span class="n">view</span><span class="o">.</span><span class="n">bounds</span><span class="p">)</span>
<span class="n">hkView</span><span class="o">.</span><span class="n">videoGravity</span> <span class="o">=</span> <span class="kt">AVLayerVideoGravity</span><span class="o">.</span><span class="n">resizeAspectFill</span>
<span class="n">hkView</span><span class="o">.</span><span class="nf">attachStream</span><span class="p">(</span><span class="n">stream</span><span class="p">)</span>

<span class="c1">// add ViewController#view</span>
<span class="n">view</span><span class="o">.</span><span class="nf">addSubview</span><span class="p">(</span><span class="n">hkView</span><span class="p">)</span>

<span class="n">connection</span><span class="o">.</span><span class="nf">connect</span><span class="p">(</span><span class="s">"rtmp://localhost/appName/instanceName"</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">play</span><span class="p">(</span><span class="s">"streamName"</span><span class="p">)</span>
</code></pre>
<h3 id='authentication' class='heading'>Authentication</h3>
<pre class="highlight swift"><code><span class="k">var</span> <span class="nv">connection</span> <span class="o">=</span> <span class="kt">RTMPConnection</span><span class="p">()</span>
<span class="n">connection</span><span class="o">.</span><span class="nf">connect</span><span class="p">(</span><span class="s">"rtmp://username:password@localhost/appName/instanceName"</span><span class="p">)</span>
</code></pre>
<h2 id='srt-usage' class='heading'>📓 SRT Usage</h2>
<h3 id='ingest' class='heading'>Ingest</h3>
<pre class="highlight swift"><code><span class="k">let</span> <span class="nv">connection</span> <span class="o">=</span> <span class="kt">SRTConnection</span><span class="p">()</span>
<span class="k">let</span> <span class="nv">stream</span> <span class="o">=</span> <span class="kt">SRTStream</span><span class="p">(</span><span class="nv">connection</span><span class="p">:</span> <span class="n">connection</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">attachAudio</span><span class="p">(</span><span class="kt">AVCaptureDevice</span><span class="o">.</span><span class="nf">default</span><span class="p">(</span><span class="nv">for</span><span class="p">:</span> <span class="o">.</span><span class="n">audio</span><span class="p">))</span> <span class="p">{</span> <span class="n">error</span> <span class="k">in</span>
    <span class="c1">// print(error)</span>
<span class="p">}</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">attachCamera</span><span class="p">(</span><span class="kt">AVCaptureDevice</span><span class="o">.</span><span class="nf">default</span><span class="p">(</span><span class="o">.</span><span class="n">builtInWideAngleCamera</span><span class="p">,</span> <span class="nv">for</span><span class="p">:</span> <span class="o">.</span><span class="n">video</span><span class="p">,</span> <span class="nv">position</span><span class="p">:</span> <span class="o">.</span><span class="n">back</span><span class="p">),</span> <span class="nv">track</span><span class="p">:</span> <span class="mi">0</span><span class="p">)</span> <span class="p">{</span> <span class="n">_</span><span class="p">,</span> <span class="n">error</span> <span class="k">in</span>
  <span class="k">if</span> <span class="k">let</span> <span class="nv">error</span> <span class="p">{</span>
    <span class="n">logger</span><span class="o">.</span><span class="nf">warn</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
  <span class="p">}</span>
<span class="p">}</span>

<span class="k">let</span> <span class="nv">hkView</span> <span class="o">=</span> <span class="kt">HKView</span><span class="p">(</span><span class="nv">frame</span><span class="p">:</span> <span class="n">view</span><span class="o">.</span><span class="n">bounds</span><span class="p">)</span>
<span class="n">hkView</span><span class="o">.</span><span class="n">videoGravity</span> <span class="o">=</span> <span class="kt">AVLayerVideoGravity</span><span class="o">.</span><span class="n">resizeAspectFill</span>
<span class="n">hkView</span><span class="o">.</span><span class="nf">attachStream</span><span class="p">(</span><span class="n">rtmpStream</span><span class="p">)</span>

<span class="c1">// add ViewController#view</span>
<span class="n">view</span><span class="o">.</span><span class="nf">addSubview</span><span class="p">(</span><span class="n">hkView</span><span class="p">)</span>

<span class="n">connection</span><span class="o">.</span><span class="nf">connect</span><span class="p">(</span><span class="s">"srt://host:port?option=foo"</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">publish</span><span class="p">()</span>
</code></pre>
<h3 id='playback' class='heading'>Playback</h3>
<pre class="highlight swift"><code><span class="k">let</span> <span class="nv">connection</span> <span class="o">=</span> <span class="kt">SRTConnection</span><span class="p">()</span>
<span class="k">let</span> <span class="nv">stream</span> <span class="o">=</span> <span class="kt">SRTStream</span><span class="p">(</span><span class="nv">connection</span><span class="p">:</span> <span class="n">connection</span><span class="p">)</span>

<span class="k">let</span> <span class="nv">hkView</span> <span class="o">=</span> <span class="kt">MTHKView</span><span class="p">(</span><span class="nv">frame</span><span class="p">:</span> <span class="n">view</span><span class="o">.</span><span class="n">bounds</span><span class="p">)</span>
<span class="n">hkView</span><span class="o">.</span><span class="n">videoGravity</span> <span class="o">=</span> <span class="kt">AVLayerVideoGravity</span><span class="o">.</span><span class="n">resizeAspectFill</span>
<span class="n">hkView</span><span class="o">.</span><span class="nf">attachStream</span><span class="p">(</span><span class="n">rtmpStream</span><span class="p">)</span>

<span class="c1">// add ViewController#view</span>
<span class="n">view</span><span class="o">.</span><span class="nf">addSubview</span><span class="p">(</span><span class="n">hkView</span><span class="p">)</span>

<span class="n">connection</span><span class="o">.</span><span class="nf">connect</span><span class="p">(</span><span class="s">"srt://host:port?option=foo"</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">play</span><span class="p">()</span>
</code></pre>
<h2 id='settings' class='heading'>📓 Settings</h2>
<h3 id='avcapturesession' class='heading'>📹 AVCaptureSession</h3>
<pre class="highlight swift"><code><span class="n">stream</span><span class="o">.</span><span class="n">frameRate</span> <span class="o">=</span> <span class="mi">30</span>
<span class="n">stream</span><span class="o">.</span><span class="n">sessionPreset</span> <span class="o">=</span> <span class="kt">AVCaptureSession</span><span class="o">.</span><span class="kt">Preset</span><span class="o">.</span><span class="n">medium</span>
</code></pre>
<h3 id='audio' class='heading'>🔊 Audio</h3>
<h4 id='a-href-https-shogo4405-github-io-haishinkit-swift-classes-ioaudiocaptureunit-html-capture-a' class='heading'><a href="https://shogo4405.github.io/HaishinKit.swift/Classes/IOAudioCaptureUnit.html">Capture</a></h4>

<p>Specifies the capture capture settings.</p>
<pre class="highlight swift"><code><span class="k">let</span> <span class="nv">front</span> <span class="o">=</span> <span class="kt">AVCaptureDevice</span><span class="o">.</span><span class="nf">default</span><span class="p">(</span><span class="nv">for</span><span class="p">:</span> <span class="o">.</span><span class="n">audio</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">attachAudio</span><span class="p">(</span><span class="n">front</span><span class="p">,</span> <span class="nv">track</span><span class="p">:</span> <span class="mi">0</span><span class="p">)</span> <span class="p">{</span> <span class="n">audioUnit</span><span class="p">,</span> <span class="n">error</span> <span class="k">in</span>
<span class="p">}</span>
</code></pre>
<h4 id='a-href-https-shogo4405-github-io-haishinkit-swift-structs-ioaudiomixersettings-html-audiomixersettings-a' class='heading'><a href="https://shogo4405.github.io/HaishinKit.swift/Structs/IOAudioMixerSettings.html">AudioMixerSettings</a></h4>

<p>When you specify the sampling rate, it will perform resampling. Additionally, in the case of multiple channels, downsampling can be applied.</p>
<pre class="highlight swift"><code><span class="c1">// If you want to mix multiple audio tracks, please enable the Feature flag.</span>
<span class="c1">// FeatureUtil.setEnabled(for: .multiTrackAudioMixing, isEnabled: true)</span>
<span class="n">stream</span><span class="o">.</span><span class="n">audioMixerSettings</span> <span class="o">=</span> <span class="kt">IOAudioMixerSettings</span><span class="p">(</span>
  <span class="nv">channels</span><span class="p">:</span> <span class="kt">UInt32</span> <span class="o">=</span> <span class="mi">1</span><span class="p">,</span>
  <span class="nv">sampleRate</span><span class="p">:</span> <span class="kt">Float64</span> <span class="o">=</span> <span class="mi">44100</span><span class="p">,</span>
<span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="n">audioMixerSettings</span><span class="o">.</span><span class="n">isMuted</span> <span class="o">=</span> <span class="kc">false</span>
<span class="n">stream</span><span class="o">.</span><span class="n">audioMixerSettings</span><span class="o">.</span><span class="n">mainTrack</span> <span class="o">=</span> <span class="mi">0</span>
<span class="n">stream</span><span class="o">.</span><span class="n">audioMixerSettings</span><span class="o">.</span><span class="n">tracks</span> <span class="o">=</span> <span class="p">[</span>
  <span class="mi">0</span><span class="p">:</span> <span class="o">.</span><span class="nf">init</span><span class="p">(</span>
    <span class="nv">isMuted</span><span class="p">:</span> <span class="kt">Bool</span> <span class="o">=</span> <span class="kc">false</span><span class="p">,</span>
    <span class="nv">downmix</span><span class="p">:</span> <span class="kt">Bool</span> <span class="o">=</span> <span class="kc">true</span><span class="p">,</span>
    <span class="nv">channelMap</span><span class="p">:</span> <span class="p">[</span><span class="kt">Int</span><span class="p">]?</span> <span class="o">=</span> <span class="kc">nil</span>
  <span class="p">)</span>
<span class="p">]</span>
</code></pre>
<h4 id='a-href-https-shogo4405-github-io-haishinkit-swift-structs-audiocodecsettings-html-audiocodecsettings-a' class='heading'><a href="https://shogo4405.github.io/HaishinKit.swift/Structs/AudioCodecSettings.html">AudioCodecSettings</a></h4>
<pre class="highlight swift"><code><span class="n">stream</span><span class="o">.</span><span class="n">audioSettings</span> <span class="o">=</span> <span class="kt">AudioCodecSettings</span><span class="p">(</span>
  <span class="nv">bitRate</span><span class="p">:</span> <span class="kt">Int</span> <span class="o">=</span> <span class="mi">64</span> <span class="o">*</span> <span class="mi">1000</span><span class="p">,</span>
<span class="p">)</span>
</code></pre>
<h3 id='video' class='heading'>🎥 Video</h3>
<h4 id='a-href-https-shogo4405-github-io-haishinkit-swift-classes-iovideocaptureunit-html-capture-a' class='heading'><a href="https://shogo4405.github.io/HaishinKit.swift/Classes/IOVideoCaptureUnit.html">Capture</a></h4>

<p>Specifies the video capture settings.</p>
<pre class="highlight swift"><code><span class="k">let</span> <span class="nv">front</span> <span class="o">=</span> <span class="kt">AVCaptureDevice</span><span class="o">.</span><span class="nf">default</span><span class="p">(</span><span class="o">.</span><span class="n">builtInWideAngleCamera</span><span class="p">,</span> <span class="nv">for</span><span class="p">:</span> <span class="o">.</span><span class="n">video</span><span class="p">,</span> <span class="nv">position</span><span class="p">:</span> <span class="o">.</span><span class="n">front</span><span class="p">)</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">attachCamera</span><span class="p">(</span><span class="n">front</span><span class="p">,</span> <span class="nv">track</span><span class="p">:</span> <span class="mi">0</span><span class="p">)</span> <span class="p">{</span> <span class="n">videoUnit</span><span class="p">,</span> <span class="n">error</span> <span class="k">in</span>
  <span class="n">videoUnit</span><span class="p">?</span><span class="o">.</span><span class="n">isVideoMirrored</span> <span class="o">=</span> <span class="kc">true</span>
  <span class="n">videoUnit</span><span class="p">?</span><span class="o">.</span><span class="n">preferredVideoStabilizationMode</span> <span class="o">=</span> <span class="o">.</span><span class="n">standard</span>
  <span class="n">videoUnit</span><span class="p">?</span><span class="o">.</span><span class="n">colorFormat</span> <span class="o">=</span> <span class="n">kCVPixelFormatType_420YpCbCr8BiPlanarVideoRange</span>
<span class="p">}</span>
</code></pre>
<h4 id='a-href-https-shogo4405-github-io-haishinkit-swift-structs-videomixersettings-html-videomixersettings-a' class='heading'><a href="https://shogo4405.github.io/HaishinKit.swift/Structs/VideoMixerSettings.html">VideoMixerSettings</a></h4>
<pre class="highlight swift"><code><span class="n">stream</span><span class="o">.</span><span class="n">videoMixerSettings</span> <span class="o">=</span> <span class="nf">init</span><span class="p">(</span>
    <span class="nv">mode</span><span class="p">:</span> <span class="kt">Mode</span><span class="p">,</span>
    <span class="nv">cornerRadius</span><span class="p">:</span> <span class="kt">CGFloat</span><span class="p">,</span>
    <span class="nv">regionOfInterest</span><span class="p">:</span> <span class="kt">CGRect</span><span class="p">,</span>
    <span class="nv">direction</span><span class="p">:</span> <span class="kt">ImageTransform</span>
<span class="p">)</span>
</code></pre>
<h4 id='a-href-https-shogo4405-github-io-haishinkit-swift-structs-videocodecsettings-html-videocodecsettings-a' class='heading'><a href="https://shogo4405.github.io/HaishinKit.swift/Structs/VideoCodecSettings.html">VideoCodecSettings</a></h4>
<pre class="highlight swift"><code><span class="n">stream</span><span class="o">.</span><span class="n">videoSettings</span> <span class="o">=</span> <span class="kt">VideoCodecSettings</span><span class="p">(</span>
  <span class="nv">videoSize</span><span class="p">:</span> <span class="o">.</span><span class="nf">init</span><span class="p">(</span><span class="nv">width</span><span class="p">:</span> <span class="mi">854</span><span class="p">,</span> <span class="nv">height</span><span class="p">:</span> <span class="mi">480</span><span class="p">),</span>
  <span class="nv">profileLevel</span><span class="p">:</span> <span class="n">kVTProfileLevel_H264_Baseline_3_1</span> <span class="k">as</span> <span class="kt">String</span><span class="p">,</span>
  <span class="nv">bitRate</span><span class="p">:</span> <span class="mi">640</span> <span class="o">*</span> <span class="mi">1000</span><span class="p">,</span>
  <span class="nv">maxKeyFrameIntervalDuration</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span>
  <span class="nv">scalingMode</span><span class="p">:</span> <span class="o">.</span><span class="n">trim</span><span class="p">,</span>
  <span class="nv">bitRateMode</span><span class="p">:</span> <span class="o">.</span><span class="n">average</span><span class="p">,</span>
  <span class="nv">allowFrameReordering</span><span class="p">:</span> <span class="kc">nil</span><span class="p">,</span>
  <span class="nv">isHardwareEncoderEnabled</span><span class="p">:</span> <span class="kc">true</span>
<span class="p">)</span>
</code></pre>
<h3 id='️-recording' class='heading'>⏺️ Recording</h3>
<pre class="highlight swift"><code><span class="c1">// Specifies the recording settings. 0" means the same of input.</span>
<span class="k">var</span> <span class="nv">recorder</span> <span class="o">=</span> <span class="kt">IOStreamRecorder</span><span class="p">()</span>
<span class="n">stream</span><span class="o">.</span><span class="nf">addObserver</span><span class="p">(</span><span class="n">recorder</span><span class="p">)</span>

<span class="n">recorder</span><span class="o">.</span><span class="n">settings</span> <span class="o">=</span> <span class="p">[</span>
  <span class="kt">AVMediaType</span><span class="o">.</span><span class="nv">audio</span><span class="p">:</span> <span class="p">[</span>
    <span class="kt">AVFormatIDKey</span><span class="p">:</span> <span class="kt">Int</span><span class="p">(</span><span class="n">kAudioFormatMPEG4AAC</span><span class="p">),</span>
    <span class="kt">AVSampleRateKey</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
    <span class="kt">AVNumberOfChannelsKey</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
    <span class="c1">// AVEncoderBitRateKey: 128000,</span>
  <span class="p">],</span>
  <span class="kt">AVMediaType</span><span class="o">.</span><span class="nv">video</span><span class="p">:</span> <span class="p">[</span>
    <span class="kt">AVVideoCodecKey</span><span class="p">:</span> <span class="kt">AVVideoCodecH264</span><span class="p">,</span>
    <span class="kt">AVVideoHeightKey</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
    <span class="kt">AVVideoWidthKey</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
    <span class="cm">/*
    AVVideoCompressionPropertiesKey: [
      AVVideoMaxKeyFrameIntervalDurationKey: 2,
      AVVideoProfileLevelKey: AVVideoProfileLevelH264Baseline30,
      AVVideoAverageBitRateKey: 512000
    ]
    */</span>
  <span class="p">]</span>
<span class="p">]</span>

<span class="n">recorder</span><span class="o">.</span><span class="nf">startRunning</span><span class="p">()</span>
<span class="c1">// recorder.stopRunning()</span>
</code></pre>
<h2 id='license' class='heading'>📜 License</h2>

<p>BSD-3-Clause</p>

          </section>
        </section>
        <section id="footer">
          <p>&copy; 2024 <a class="link" href="https://github.com/shogo4405/HaishinKit.swift" target="_blank" rel="external noopener">shogo4405</a>. All rights reserved. (Last updated: 2024-04-22)</p>
          <p>Generated by <a class="link" href="https://github.com/realm/jazzy" target="_blank" rel="external noopener">jazzy ♪♫ v0.14.4</a>, a <a class="link" href="https://realm.io" target="_blank" rel="external noopener">Realm</a> project.</p>
        </section>
      </article>
    </div>
  </body>
</html>
